from reportlab.pdfgen import canvas
#from reportlab.lib.units import mm
from reportlab.graphics.barcode import code128
import os

inch = INCH = 72
cm = CM = inch / 2.54
mm = cm / 10.0

#x,y,y2
verticales=[
    (0,74,0),
    (70,74,67),
    (105,67,54),
    (105,31,0),
    (125,54,23),
    (130,74,67),
    (145,15.5,8),
    (158,54,31),
    (210,74,0)
    ]


#x,y,x2
horizontales=[
    (0,74,210),
    (0,67,210),
    (0,54,210),
    (125,46,158),
    (125,38.5,158),
    (0,31,210),
    (105,23,210),
    (105,15.5,210),
    (105,8,210),
    (0,0,210)
    ]


cadres=[
    (0,0,210,74)
 ]
# x,y,texte
# x+0.5, y+2
labels9pts=[
    (0.5+5,72,'DESTINATAIRE'),
    (70.5,72,'POINT DE'),
    (70.5,70,'DECHARGEMENT'),
    (130.5,72,'EXPEDITEUR'),
    (0.5+5,65,'CODE'),
    (0.5+5,63,'ROUTAGE'),
    (105.5,65,'POINT DE'),
    (105.5,63,'DESTINATION'),
    (0.5+5,52,'CODE'),
    (0.5+5,50,'PRODUIT (P)'),
    (125.5,52,'Pds NET'),
    (125.5,44,'Pds BRUT'),
    (125.5,36.5,'DATE'),
    (158.5,52,'QUANTITE (Q)'),
    (0.5+5,29,'No ETIQUETTE (S)'),
    (105.5,29,'NB'),
    (125.5,29,'DESCRIPTION'),
    (105.5,21,'REF. FOURNISSEUR (30S)'),
    (105.5,13.5,'No LOT'),
    (145.5,13.5,'INDICE'),
    (145.5,11.5,'MODIF'),
    (105.5,6,'CODE'),
    (105.5,4,'VENDEUR (V)'),
    (205-5,1,'ETI9'),
    (0.5+5,1,'SERMO 44000 - Aigrefeuille - France')
    ]

def draw_eti9(canvas,x,y,
        destinataire='RENAULT PALENCIA',
        pt_decharg='173GR2    01',
        pt_destination='A0 51 14 XXX',
        expediteur='SERMO SASU',
        code_routage='B5 25/07 04.00',
        code_produit='123456901234578',
        quant=9999,
        ref_fournisseur='100143.010.000',
        no_etiq=678,
        poids_net=99.00,
        poids_brut=99.00,
        date='071016',
        nb=1,
        description='BAGUETTE DECORATIVE TEST',
        no_lot='100143.010.000',
        ind_modif='AA',
        code_vendeur='00059651'
    ):
    c=canvas
    c.saveState()
    c.translate(x*mm,y*mm)
    c.setStrokeColorRGB(0,0,0)
    c.setLineWidth(0.2*mm)
    for (x,y,x2) in horizontales:
        c.line(x*mm,y*mm,x2*mm,y*mm)

    for (x,y,y2) in verticales:
        c.line(x*mm,y*mm,x*mm,y2*mm)

    c.setLineWidth(0.5*mm)
    for (x1,y1,x2,y2) in cadres:
        c.rect(x1*mm,y1*mm,(x2-x1)*mm,(y2-y1)*mm)

    for (x,y,label) in labels9pts:
        t = c.beginText(x*mm, y*mm)
        t.setFont('Helvetica-Bold',6)
        t.setHorizScale(70)
        t.textOut(label)
        c.drawText(t)

    ##########################
    # Zones de texte variables
    # x,y,texte,taille,%larg/haut
    print 'zones'

    zones=[
        (12+5,67.5,destinataire,7,50),
        (84,67.5,pt_decharg,7,70),
        (141,67.5,expediteur,7,80),
        
        (117,55,pt_destination,14,80),
        (11+5,41.5,code_produit,17,70),

        (134,47,'%s KGM' % round(poids_net,2) ,7,70),
        (134,40.5,'%s KGM' % round(poids_brut,2),7,70),
        (132,31.5,'D%s'%date,7,80),

        (169,43,'%i'%quant,14,80),

        (14+5,20,'%i'% no_etiq,14.5,80),
        (108,24,'%i'% nb,9,80),
        (136,25,description,7,50),
        (108,16,ref_fournisseur,4,80),
        (110,9,no_lot,4,80),
        (155,9,ind_modif,8,90),
        (120,1,code_vendeur,4,80),

        ]

    for (x,y,text,size,ratio) in zones:
        t = c.beginText(x*mm, y*mm)
        t.setFont('Helvetica-Bold',size*mm)
        t.setHorizScale(ratio)
        t.textOut(text)
        c.drawText(t)


    zonesinverses=[
        (11+5,55,code_routage,14,80),
        ]

    c.saveState()
    for (x,y,text,size,ratio) in zonesinverses:
        t = c.beginText(x*mm, y*mm)
        t.setFont('Helvetica-Bold',size*mm)
        t.setHorizScale(ratio)
        t.setStrokeColorRGB(1,1,1)
        t.setFillColorRGB(1,1,1)
        t.textOut(text)
        largeur_texte=(t.getX()-x*mm)*ratio/100
        hauteur_texte=size/1.17
        c.setStrokeColorRGB(0,0,0)
        c.setFillColorRGB(0,0,0)
        c.rect((x)*mm,(y)*mm,largeur_texte+1*mm,hauteur_texte*mm,1,1)

        c.drawText(t)
    c.restoreState()

    # x,y,texte,hauteur,larg barre
    barres=(
        (2+5,31.5,'P%s' % code_produit,9,1.2),
        (159,31.5,'Q%i' % quant,9,1.2),
        (2+5,3,'S%i' % no_etiq,13,1.2),
        (135,16,ref_fournisseur,6.5,0.8),
        (150,0.5,'V%s' % code_vendeur,6.5,0.8)
        )
        
    for (x,y,texte,haut,largbarre) in barres:
        bc = code128.Code128(texte,barHeight = haut*mm,barWidth=largbarre)
        #bc._showBoundary=True
        bc.drawOn(c,x*mm,y*mm)

    c.restoreState()

if __name__=='__main__':
    c = canvas.Canvas("d:\eti9.pdf")
    draw_eti9(c,0,297-74-10)

    c.rotate(-90)
    c.translate(-297*mm,0)
    draw_eti9(c,0+74+10,210-74-10)
    #eti9(c,74+6,-210+6+75)

    c.showPage()
    c.save()
    os.startfile('d:\eti9.pdf')